#include "../global.h"

MyMachine::MyMachine(Epp *e, ScreenOutput *disp, AudioOutput *au, Keyboard *kb, Joystick *js) :
                                               Machine(e, disp, au) {

    keyboard=kb;
    joystick=js;
}

void MyMachine::readROMs(void) {

    readROM("roms/???", memory+0x0000, 0x0800);

    readROM("roms/???", charROM+0x0000, 0x0800);
}

void MyMachine::createComponents(void) {

    cpu = new _CPUCLASS_(this);
    vid = new MyMachineVideo(this, display, charROM);
}

void MyMachine::destroyComponents(void) {

    delete cpu;
    delete vid;
}

void MyMachine::emulate() {

    readROMs();

    createComponents();
    vid->setupDisplay();
    vid->createBanks();

    cpu->setRunTime(1000000/60); // This is 1 MHz, alter as required

    for(;;) {

        joystick->update();

        cpu->execute();

        // Interrupt here?

        vid->update();
        audio->update();

        if(epp->checkInterface()) {

            destroyComponents();
            return;
        }
    }
}

void MyMachine::reset(void) {

    cpu->reset();
}

uint8 MyMachine::readMem(const Component *comp, const uint16 addr) {

    // Read from memory and memory-mapped devices
}

void MyMachine::writeMem(const Component *comp, const uint16 addr, const uint8 data) {

    // Writes to memory and memory-mapped devices go here.  Remeber to write protect the ROM!
}

uint8 MyMachine::in(const Component *comp, const uint16 port) {

    // Input from IO port
}

void MyMachine::out(const Component *comp, const uint16 port, const uint8 data) {

    // Output to IO port
}
