class Epp {

    public:
    
    Epp(ScreenOutput *, AudioOutput *, Keyboard *, Joystick *, Mouse *);
    ~Epp();
    void setMachine(Machine *);
    void start(void);
    bool checkInterface(void);
    uint8 getSetting(char *, uint8);

    static void resetLog(void);
    static void log(char *);

    static Machine *getMachineByName(const char *, Epp *, ScreenOutput *, AudioOutput *, Keyboard *, Joystick *, Mouse *);

    private:
    
    uint16 setupScreen(void);
    void teleprint(int16, int16, char *);
    void wipe(int16, int16, int16, int16);
    void setupAudio(void);
    void freeAudio(void);

    Machine *machine;
    ScreenOutput *display;
    AudioOutput *audio;
    Keyboard *keyboard;
    Joystick *joystick;
    Mouse *mouse;

    void *samples[4];
    void *channel;
};
