#include "global.h"

Machine::Machine(Epp *e, ScreenOutput *disp, AudioOutput *au) {

    Epp::log("Creating emulated machine.");

	epp=e;
    display=disp;
    audio=au;
}

void Machine::readROM(const char *name, uint8 *dest, const uint32 size) {

	ifstream input(name, ios::in|ios::bin);

  	input.read(dest, size);

    if (input.gcount()!=size) {

        cerr << "Error: Only " << input.gcount() << " bytes read from file " << name << ".\nExpected " << size << " bytes.";
        Epp::log("Fatal error reading ROM.");
        exit(1);
    }
}
