#include "../../global.h"

VideoDevice::VideoDevice(Machine *hw, ScreenOutput *disp, uint8 *cr) : Component(hw) {

    Epp::log("Creating emulated Video device.");

    display=disp;
    charROM=cr;
}

uint8 *VideoDevice::decodePlaneData(uint8 planes, uint32 offset, uint32 plength) {

    int value=1;

    for(int i=0; i<8; i++) {

    	pixeldata[i]=0;
    }

	for(int i=0; i<planes; i++) {

        uint8 data=charROM[offset+(plength*i)];

		for(int pixel=0; pixel<8; pixel++) {

        	if(data & 0x01) pixeldata[pixel]+=value;
            data >>= 1;
        }

    	value<<=1;
    }

    return pixeldata;
}

void VideoDevice::setSpritePixels(uint8 *dest, uint8 *data, uint16 sprite, uint16 bank, uint16 palette, int16 x, int16 y, uint16 wid, uint8 direction) {

    for(int i=0; i<8; i++) {

		dest[x+(y*wid)]=lookupColour(sprite, data[i], bank, palette);

        switch(direction) {

        	case right:
            x++;
            break;

            case left:
            x--;
            break;

            case down:
            y++;
            break;

            case up:
            y--;
            break;

            default:
            Epp::log("Internal error! Bad direction passed to setCharData.");
            exit(1);
            break;
        }
    }
}
