class VideoDevice : public Component {

    public:

    VideoDevice(Machine *, ScreenOutput *, uint8 *);
    virtual void setupDisplay(void) = 0;
    virtual void update() = 0;
    virtual void writeVideoRAM(uint16, uint8) = 0;
    virtual void createBanks(void) = 0;

    protected:

    enum direct {right, left, down, up};

    virtual uint8 lookupColour(const uint16, const uint8, const uint16, const uint16) = 0;
    void setSpritePixels(uint8 *, uint8 *, uint16, uint16, uint16, int16, int16, uint16, uint8);
    uint8 *decodePlaneData(uint8, uint32, uint32);

    ScreenOutput *display;
    uint8 *charROM;

    private:

    uint8 pixeldata[8];
};
