#include "../global.h"

Invaders::Invaders(Epp *e, ScreenOutput *disp, AudioOutput *au, Keyboard *kb, Joystick *js) : InvadersHardware(e, disp, au, kb, js) {

}

void Invaders::readROMs(void) {

    readROM("roms/invaders.h", memory+0x0000, 0x0800);
    readROM("roms/invaders.g", memory+0x0800, 0x0800);
    readROM("roms/invaders.f", memory+0x1000, 0x0800);
    readROM("roms/invaders.e", memory+0x1800, 0x0800);

    sample[0]=audio->loadSample("samples/invaders.0");
    sample[1]=audio->loadSample("samples/invaders.1");
    sample[2]=audio->loadSample("samples/invaders.2");
    sample[3]=audio->loadSample("samples/invaders.3");
    sample[4]=audio->loadSample("samples/invaders.4");
    sample[5]=audio->loadSample("samples/invaders.5");
    sample[6]=audio->loadSample("samples/invaders.6");
    sample[7]=audio->loadSample("samples/invaders.7");
    sample[8]=audio->loadSample("samples/invaders.8");

    dip1=epp->getSetting("invaders", 0);
    dip1|=epp->getSetting("invaders", 1)<<3;
}

void Invaders::createComponents(void) {

    cpu = new Z80(this);
    vid = new InvadersVideo(this, display, NULL);
}