class PhoenixHardware : public Machine {

    public:

    PhoenixHardware(Epp *, ScreenOutput *, AudioOutput *, Keyboard *, Joystick *);

    uint8 readMem(const Component *, const uint16);
    void writeMem(const Component *, const uint16, const uint8);
    void out(const Component *, const uint16, const uint8);
    uint8 in(const Component *, const uint16);

    void emulate(void);
    void reset(void);

    protected:

    virtual void createComponents(void) = 0;
    void destroyComponents(void);
    virtual void readROMs(void) = 0;

    uint8 memory[0x10000];
    uint8 charROM[0x2000];

    Joystick *joystick;
    Keyboard *keyboard;

    Z80 *cpu;
    PhoenixVideoHardware *vid;

    void *channel[8];
    void *sample[1];

    uint8 vsync;
    uint8 dip1;
};
