#include "../global.h"

Phoenix::Phoenix(Epp *e, ScreenOutput *disp, AudioOutput *au, Keyboard *kb, Joystick *js) : PhoenixHardware(e, disp, au, kb, js) {

}

void Phoenix::readROMs(void) {

    readROM("roms/phoenix.45", memory+0x0000, 0x0800);
    readROM("roms/phoenix.46", memory+0x0800, 0x0800);
    readROM("roms/phoenix.47", memory+0x1000, 0x0800);
    readROM("roms/phoenix.48", memory+0x1800, 0x0800);
    readROM("roms/phoenix.49", memory+0x2000, 0x0800);
    readROM("roms/phoenix.50", memory+0x2800, 0x0800);
    readROM("roms/phoenix.51", memory+0x3000, 0x0800);
    readROM("roms/phoenix.52", memory+0x3800, 0x0800);

    readROM("roms/phoenix.39", charROM+0x0000, 0x0800);
    readROM("roms/phoenix.40", charROM+0x0800, 0x0800);
    readROM("roms/phoenix.23", charROM+0x1000, 0x0800);
    readROM("roms/phoenix.24", charROM+0x1800, 0x0800);

    dip1=0x40;
    dip1|=epp->getSetting("phoenix", 0);
    dip1|=epp->getSetting("phoenix", 1)<<2;
}

void Phoenix::createComponents(void) {

    cpu = new Z80(this);
    vid = new PhoenixVideo(this, display, charROM);
}