class Spectrum : public Machine {

    public:

    Spectrum(Epp *, ScreenOutput *, AudioOutput *, Keyboard *, Joystick *, const char *);

    void emulate();
    void reset(void);

    uint8 readMem(const Component *, const uint16);
    void writeMem(const Component *, const uint16, const uint8);
    uint8 in(const Component *, const uint16);
    void out(const Component *, const uint16, const uint8);


    protected:

    void createComponents(void);
    void destroyComponents(void);
    void readROMs(void);

    void readMirage(const char *);
    void readInput(void);

    uint8 memory[0x10000];
    int8 sample[44100/50];

    const char *snapshot;

    Keyboard *keyboard;
    Joystick *joystick;

    uint8 keyvalue[8];
    uint8 stickvalue;

    Z80 *cpu;
    SinclairVideo *vid;

    uint16 sndpos;
    bool sndflag;

};
